package context

import (
	"net/http"

	"git.polynom.me/rio/internal/gitea"
	"git.polynom.me/rio/internal/metrics"
	"github.com/patrickmn/go-cache"
)

type CacheContext struct {
	// Cache for general repository information
	RepositoryInformationCache cache.Cache
}

type GlobalContext struct {
	DefaultCSP   string
	PagesDomain  string
	Gitea        *gitea.GiteaClient
	MetricConfig *metrics.LokiMetricConfig
	Cache        *CacheContext
}

type Context struct {
	Username string
	Reponame string
	Domain   string
	Path     string

	// HTTP Stuff
	Referrer  string
	UserAgent string
	Writer    http.ResponseWriter

	// Pointer to the global context
	Global *GlobalContext
}
